from locust import HttpLocust, TaskSet, task, between
from requests_toolbelt.adapters.source import SourceAddressAdapter
import random
import requests
import urllib3
urllib3.disable_warnings()

def login(self):
    #ua = pick_ua()
    self.client.get("/login.php", auth=("admin", "password"))

def pick_ua():
    ua1 = "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_11_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/61.0.3163.100 Safari/537.36"
    ua2 = "Mozilla/5.0 (iPhone; CPU iPhone OS 5_1_1 like Mac OS X) AppleWebKit/534.46 (KHTML, like Gecko) Version/5.1 Mobile/9B206 Safari/7534.48.3"
    ua3 = "Mozilla/5.0 (Windows NT 6.1; WOW64; rv:29.0) Gecko/20100101 Firefox/29.0"
    ua4 = "Mozilla/5.0 (Windows NT 6.3; WOW64; Trident/7.0; Touch; rv:11.0) like Gecko"
    ua5 = "Mozilla/5.0(iPad; U; CPU OS 4_3 like Mac OS X; en-us) AppleWebKit/533.17.9 (KHTML, like Gecko) Version/5.0.2 Mobile/8F191 Safari/6533.18.5"
    ua = [ua1, ua2, ua3, ua4, ua5]
    return(random.choice(ua))

class UserBehavior(TaskSet):

    # def on_start(self):
    #     self.new_session()

    # @task(1)
    # def new_session(self):
    #     if self.locust.session:
    #         self.locust.session.end()
    #     self.locust.session.create()
    #     ips = ["161.98.255.1", "37.60.63.2", "206.223.191.1", "23.26.110.2", "27.113.239.2", "42.97.255.1", "132.247.255.2", "14.192.95.1", "37.16.63.1", "49.213.31.2", "41.67.128.1", "27.97.1.2"]
    #     ip = random.choice(ips)
    #     self.client.verify = False
    #     #requests.packages.urllib3.util.ssl_.DEFAULT_CIPHERS += '{cipher}'.format(cipher=currentcipher) 
    #     requests.packages.urllib3.util.ssl_.DEFAULT_CIPHERS += 'ECDHE-RSA-AES256-SHA'
    #     self.client.mount("https://", SourceAddressAdapter(ip))
    #     self.client.mount("http://", SourceAddressAdapter(ip))
    #     login(self)

    # def logout(l):
    #     l.client.post("/logout", {"username":"ellen_key", "password":"education"})

    @task(100)
    def index(self):
        ua = pick_ua()
        self.client.get("/index.php", headers={'user-agent': ua}, cookies=self.locust.client.cookies.get_dict(), verify=False)

    @task(100)
    def about(self):
        ua = pick_ua()
        self.client.get("/about.php", headers={'user-agent': ua}, cookies=self.locust.client.cookies.get_dict(), verify=False)

    @task(100)
    def security(self):
        ua = pick_ua()
        self.client.get("/security.php", headers={'user-agent': ua}, cookies=self.locust.client.cookies.get_dict(), verify=False)

    @task(10)
    def vuln_xss(self):
        ua = pick_ua()
        self.client.post("/vulnerabilities/exec/", headers={'user-agent': ua}, cookies=self.locust.client.cookies.get_dict(), data={"ip": "ping 127.0.0.1 & cat /etc/passwd", "Submit": "Submit"}, verify=False)
        # with self.client.post("/vulnerabilities/exec/", headers={'user-agent': ua}, cookies=self.locust.client.cookies.get_dict(), data={"ip": "ping 127.0.0.1 & cat /etc/passwd", "Submit": "Submit"}, verify=False, catch_response=True) as response:
        #     if response.status_code == 403:
        #         response.success()

    @task(10)
    def vuln_sqli(self):
        ua = pick_ua()      
        self.client.post("/vulnerabilities/sqli/", headers={'user-agent': ua}, cookies=self.locust.client.cookies.get_dict(), data={"id": "%' and 1=0 union select null, concat(first_name,0x0a,last_name,0x0a,user,0x0a,password) from users #","Submit": "Submit"},verify=False)
        # with self.client.post("/vulnerabilities/sqli/", headers={'user-agent': ua}, cookies=self.locust.client.cookies.get_dict(), data={"id": "%' and 1=0 union select null, concat(first_name,0x0a,last_name,0x0a,user,0x0a,password) from users #","Submit": "Submit"},verify=False, catch_response=True) as response:
        #     if response.status_code == 403:
        #         response.success()

    @task(100)
    def instructions(self):
        ua = pick_ua()
        self.client.get("/instructions.php", headers={'user-agent': ua}, cookies=self.locust.client.cookies.get_dict(), verify=False)


    def on_start(self):
        # List of IP's that can be used as "source" - hardcoded for simplicity
        ips = ["161.98.255.1", "37.60.63.2", "206.223.191.1", "23.26.110.2", "27.113.239.2", "42.97.255.1", "132.247.255.2", "14.192.95.1", "37.16.63.1", "49.213.31.2", "41.67.128.1", "27.97.1.2"]
        ip = random.choice(ips)
        self.client.verify = False
        #requests.packages.urllib3.util.ssl_.DEFAULT_CIPHERS += '{cipher}'.format(cipher=currentcipher) 
        requests.packages.urllib3.util.ssl_.DEFAULT_CIPHERS += 'ECDHE-RSA-AES256-SHA'
        self.client.mount("https://", SourceAddressAdapter(ip))
        self.client.mount("http://", SourceAddressAdapter(ip))
        login(self)

    # def on_stop(self):
    #     logout(self)

class WebsiteUser(HttpLocust):
    task_set = UserBehavior
    wait_time = between(5, 9)
    #min_wait = 5000
    #max_wait = 9000